#include <windows.h>
#include <Shlobj.h>
#include <Shlwapi.h>
#include <assert.h>
typedef uintptr_t addr;
#include "MemoryMgr.h"

struct ddraw_dll
{
	HMODULE dll;
	FARPROC AcquireDDThreadLock;
	FARPROC CompleteCreateSysmemSurface;
	FARPROC D3DParseUnknownCommand;
	FARPROC DDGetAttachedSurfaceLcl;
	FARPROC DDInternalLock;
	FARPROC DDInternalUnlock;
	FARPROC DSoundHelp;
	FARPROC DirectDrawCreate;
	FARPROC DirectDrawCreateClipper;
	FARPROC DirectDrawCreateEx;
	FARPROC DirectDrawEnumerateA;
	FARPROC DirectDrawEnumerateExA;
	FARPROC DirectDrawEnumerateExW;
	FARPROC DirectDrawEnumerateW;
	FARPROC DllCanUnloadNow;
	FARPROC DllGetClassObject;
	FARPROC GetDDSurfaceLocal;
	FARPROC GetOLEThunkData;
	FARPROC GetSurfaceFromDC;
	FARPROC RegisterSpecialCase;
	FARPROC ReleaseDDThreadLock;
	FARPROC SetAppCompatData;
} ddraw;

__declspec(naked) void _AcquireDDThreadLock() { _asm { jmp[ddraw.AcquireDDThreadLock] } }
__declspec(naked) void _CompleteCreateSysmemSurface() { _asm { jmp[ddraw.CompleteCreateSysmemSurface] } }
__declspec(naked) void _D3DParseUnknownCommand() { _asm { jmp[ddraw.D3DParseUnknownCommand] } }
__declspec(naked) void _DDGetAttachedSurfaceLcl() { _asm { jmp[ddraw.DDGetAttachedSurfaceLcl] } }
__declspec(naked) void _DDInternalLock() { _asm { jmp[ddraw.DDInternalLock] } }
__declspec(naked) void _DDInternalUnlock() { _asm { jmp[ddraw.DDInternalUnlock] } }
__declspec(naked) void _DSoundHelp() { _asm { jmp[ddraw.DSoundHelp] } }
__declspec(naked) void _DirectDrawCreate() { _asm { jmp[ddraw.DirectDrawCreate] } }
__declspec(naked) void _DirectDrawCreateClipper() { _asm { jmp[ddraw.DirectDrawCreateClipper] } }
__declspec(naked) void _DirectDrawCreateEx() { _asm { jmp[ddraw.DirectDrawCreateEx] } }
__declspec(naked) void _DirectDrawEnumerateA() { _asm { jmp[ddraw.DirectDrawEnumerateA] } }
__declspec(naked) void _DirectDrawEnumerateExA() { _asm { jmp[ddraw.DirectDrawEnumerateExA] } }
__declspec(naked) void _DirectDrawEnumerateExW() { _asm { jmp[ddraw.DirectDrawEnumerateExW] } }
__declspec(naked) void _DirectDrawEnumerateW() { _asm { jmp[ddraw.DirectDrawEnumerateW] } }
__declspec(naked) void _DllCanUnloadNow() { _asm { jmp[ddraw.DllCanUnloadNow] } }
__declspec(naked) void _DllGetClassObject() { _asm { jmp[ddraw.DllGetClassObject] } }
__declspec(naked) void _GetDDSurfaceLocal() { _asm { jmp[ddraw.GetDDSurfaceLocal] } }
__declspec(naked) void _GetOLEThunkData() { _asm { jmp[ddraw.GetOLEThunkData] } }
__declspec(naked) void _GetSurfaceFromDC() { _asm { jmp[ddraw.GetSurfaceFromDC] } }
__declspec(naked) void _RegisterSpecialCase() { _asm { jmp[ddraw.RegisterSpecialCase] } }
__declspec(naked) void _ReleaseDDThreadLock() { _asm { jmp[ddraw.ReleaseDDThreadLock] } }
__declspec(naked) void _SetAppCompatData() { _asm { jmp[ddraw.SetAppCompatData] } }

HINSTANCE dllModule;
HMODULE hExecutableInstance;
TCHAR DllPath[MAX_PATH], *DllName, szSystemPath[MAX_PATH];

void
DDraw(HINSTANCE hInst)
{
	dllModule = hInst;
	hExecutableInstance = GetModuleHandle(NULL); // passing NULL should be safe even with the loader lock being held (according to ReactOS ldr.c)
	GetModuleFileName(dllModule, DllPath, MAX_PATH);
	DllName = strrchr(DllPath, '\\');
	SHGetFolderPath(NULL, CSIDL_SYSTEM, NULL, 0, szSystemPath);
	strcat_s(szSystemPath, DllName);

	ddraw.dll = LoadLibrary(szSystemPath);
	ddraw.AcquireDDThreadLock = GetProcAddress(ddraw.dll, "AcquireDDThreadLock");
	ddraw.CompleteCreateSysmemSurface = GetProcAddress(ddraw.dll, "CompleteCreateSysmemSurface");
	ddraw.D3DParseUnknownCommand = GetProcAddress(ddraw.dll, "D3DParseUnknownCommand");
	ddraw.DDGetAttachedSurfaceLcl = GetProcAddress(ddraw.dll, "DDGetAttachedSurfaceLcl");
	ddraw.DDInternalLock = GetProcAddress(ddraw.dll, "DDInternalLock");
	ddraw.DDInternalUnlock = GetProcAddress(ddraw.dll, "DDInternalUnlock");
	ddraw.DSoundHelp = GetProcAddress(ddraw.dll, "DSoundHelp");
	ddraw.DirectDrawCreate = GetProcAddress(ddraw.dll, "DirectDrawCreate");
	ddraw.DirectDrawCreateClipper = GetProcAddress(ddraw.dll, "DirectDrawCreateClipper");
	ddraw.DirectDrawCreateEx = GetProcAddress(ddraw.dll, "DirectDrawCreateEx");
	ddraw.DirectDrawEnumerateA = GetProcAddress(ddraw.dll, "DirectDrawEnumerateA");
	ddraw.DirectDrawEnumerateExA = GetProcAddress(ddraw.dll, "DirectDrawEnumerateExA");
	ddraw.DirectDrawEnumerateExW = GetProcAddress(ddraw.dll, "DirectDrawEnumerateExW");
	ddraw.DirectDrawEnumerateW = GetProcAddress(ddraw.dll, "DirectDrawEnumerateW");
	ddraw.DllCanUnloadNow = GetProcAddress(ddraw.dll, "DllCanUnloadNow");
	ddraw.DllGetClassObject = GetProcAddress(ddraw.dll, "DllGetClassObject");
	ddraw.GetDDSurfaceLocal = GetProcAddress(ddraw.dll, "GetDDSurfaceLocal");
	ddraw.GetOLEThunkData = GetProcAddress(ddraw.dll, "GetOLEThunkData");
	ddraw.GetSurfaceFromDC = GetProcAddress(ddraw.dll, "GetSurfaceFromDC");
	ddraw.RegisterSpecialCase = GetProcAddress(ddraw.dll, "RegisterSpecialCase");
	ddraw.ReleaseDDThreadLock = GetProcAddress(ddraw.dll, "ReleaseDDThreadLock");
	ddraw.SetAppCompatData = GetProcAddress(ddraw.dll, "SetAppCompatData");
}

void
patchEula(void) {
	// patches the EULA confirmation so the game runs without a EBEULA(X).DLL
	// mov al, 1; ret
	BYTE eulapatch[] = { 0xB0, 0x01, 0xC3 };

	if (*(int*)0x6146F0 == 0x042474FF)
		// AOC
		PatchBytes(0x587400, eulapatch, sizeof(eulapatch));
	else if (*(int*)0x5FB0D3 == 0x042474FF)
		// AOK
		PatchBytes(0x47B8A0, eulapatch, sizeof(eulapatch));
}

void
userPatchDlls(void)
{
	// user patch hook
	if (*(int*)0x51A3B8 == 0x2A6674) {
		// wndmode.dll crashes under WinXP (and probably below) - so let's just not load it in that case
		if ((DWORD)(LOBYTE(LOWORD(GetVersion()))) < 6)
			Patch<byte>(0x7C2815, 0xEB); // JNZ to JMP

		// If The game binary (and UP dlls) are in root folder (i.e. C:\Age of Empires II\age2_x1.exe)
		if (!PathFileExists("age2_x1\\age2_x1.exe")) {
			char miniupnpc[] = "miniupnpc.dll";
			PatchBytes(0x7DB720, miniupnpc, sizeof(miniupnpc));

			char wndmode[] = "wndmode.dll";
			PatchBytes(0x7C2D80, wndmode, sizeof(wndmode));

			char spectate[] = "spectate.exe";
			PatchBytes(0x7E6DA8, spectate, sizeof(spectate));
		}
	}
}

void
loadDlhs(void)
{
	WIN32_FIND_DATA fd;
	HANDLE hFindFile;
	char *ext, *p;
	char path[MAX_PATH];

	hFindFile = FindFirstFile("Mods\\*.dlh", &fd);
	if(hFindFile != INVALID_HANDLE_VALUE){
		do {
			if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				ext = strrchr(fd.cFileName, '.');
				for (p = ext; *p; p++)
					*p = tolower(*p);
				if (strcmp(ext, ".dlh") == 0) {
					strcpy_s(path, "Mods\\");
					strcat_s(path, fd.cFileName);
					LoadLibrary(path);
				}
			}
		} while (FindNextFile(hFindFile, &fd));
		FindClose(hFindFile);
	}
}

BOOL WINAPI
DllMain(HINSTANCE hInst, DWORD reason, LPVOID)
{
	if(reason == DLL_PROCESS_ATTACH){
		DDraw(hInst);

		if (!PathFileExists("data\\graphics.drs"))
			SetCurrentDirectory("..\\");

		patchEula();
		userPatchDlls();
		loadDlhs();
	}

	if(reason == DLL_PROCESS_DETACH)
		FreeLibrary(ddraw.dll);

	return TRUE;
}
